# ■ Lyapunov fractalの描画
from tkinter import *
import math
MD=5
STR=[0,0,1,0,1] # MDの個数　(0がA, 1がBを示す。この場合AABABを示す。
#MD=2
#STR=[0,1] # MDの個数　(0がA, 1がBを示す。この場合ABを示す。
# ■ Lyapunov指数の計算
def lamda(a, b):
    global MD,STR
    try:
        x0=0.5; N=1000; lam=0
        for n in range(1,N):
            if STR[n % MD]==0: rn = a
            else :rn = b
            xn = rn * x0 * (1-x0)
            rr=abs(rn*(1-2*xn))
            if rr !=0 : lam+= math.log(rr)
            x0=xn
        return lam/N
    except :
        print("error", a,b)
        return 0
MAX=200; DV=int(MAX/4)
root=Tk(); root.title("Lyapunov")
canvas=Canvas(root,width=MAX,height=MAX)
canvas.pack()
k=0; NK=1; checkN=int(MAX/20)
for i in range(MAX):
    k+=1
    if (k % checkN) ==0: # 描画中の表示
        canvas.delete("DT")
        canvas.create_text(100,20,text="描画中です(%2d %%)" % int(k/MAX*100),
                           font=('Times',10),fill='#FF0000', tag="DT")
        canvas.create_text(100,40,text="■"*NK,
                           font=('Times',10),fill='#FF0000', tag="DT")
        NK+=1
        if NK>20: NK=1
        root.update()
    a=i/DV
    for j in range(MAX):
        b=j/DV
        if a==0 or b==0 :lm=0 
        else : lm=lamda(a,b)
        if lm>0:
            CC=int(255*lm)
            if CC>255: CC=255
            C="#FF%02X%02X" % (CC,CC)
        else:
            CC=int(255*math.exp(lm))
            if CC>255: CC=255
            C="#%02X%02XFF" % (CC,CC)
        canvas.create_rectangle(i,j,i,j,fill=C,outline="")
canvas.delete("DT")
root.update()
root.mainloop()
    
